/*
DO NOT EDIT THIS FILE!

This file is autogenerated from "--update" and will be replaced
every build time

*/

// Self include
#include "turtleplugin.h"
#include "turtlemodulebase.h"
#include "turtlemodule.h"
#include <kumir2-libs/widgets/declarativesettingspage.h>
#include <QApplication>

namespace ActorTurtle {


QVariant encode(const Color & record) {
    QVariantList result;
    result << QVariant(record.r);
    result << QVariant(record.g);
    result << QVariant(record.b);
    result << QVariant(record.a);

    return result;
}

Color decode(const QVariant & raw) {
    Color result;
    const QVariantList alist = raw.toList();
    result.r = alist.size() > 0 ? alist.at(0).toInt() : 0;
    result.g = alist.size() > 1 ? alist.at(1).toInt() : 0;
    result.b = alist.size() > 2 ? alist.at(2).toInt() : 0;
    result.a = alist.size() > 3 ? alist.at(3).toInt() : 0;

    return result;
}
            


TurtlePlugin::TurtlePlugin()
    : ExtensionSystem::KPlugin()
    , module_(nullptr)
    , asyncRunThread_(nullptr)
    , settingsPage_(nullptr)
{
    //bool hasGuiThread = true;
#ifdef Q_OS_LINUX
    //hasGuiThread = getenv("DISPLAY") != 0;
#endif
    QObject::connect(
        this, SIGNAL(asyncRun(quint32,QVariantList)),
        this, SLOT(asyncEvaluate(quint32,QVariantList)),
        //hasGuiThread? Qt::QueuedConnection :
        Qt::DirectConnection
    );
}

/* protected */ QList<ExtensionSystem::CommandLineParameter> TurtlePlugin::acceptableCommandLineParameters() const
{
    return TurtleModule::acceptableCommandLineParameters();
}

/* public */ QVariantList TurtlePlugin::algOptResults() const
{
    return optResults_;
}

/* public */ QByteArray TurtlePlugin::asciiModuleName() const
{
    return QByteArray("turtle");
}

/* private slot */ void TurtlePlugin::asyncEvaluate(quint32 index, const QVariantList & args)
{
    using namespace Shared;
    errorText_.clear();
    result_ = QVariant::Invalid;
    optResults_.clear();
    switch (index) {
        case 0x0000: {
            /* tailUp */
            module_->runTailUp();
            break;
        }
        
        case 0x0001: {
            /* tailDown */
            module_->runTailDown();
            break;
        }
        
        
        default : {
            errorText_ = "Unknown method index for async evaluation";
        }
    }
    Q_EMIT sync();
}

/* protected */ void TurtlePlugin::changeGlobalState(ExtensionSystem::GlobalState old, ExtensionSystem::GlobalState current)
{
    module_->changeGlobalState(old, current);
}

/* public */ void TurtlePlugin::connectSync(QObject* receiver, const char* method)
{
    QObject::connect(this, SIGNAL(sync()), receiver, method, Qt::DirectConnection);
}

/* protected */ void TurtlePlugin::createPluginSpec()
{
    _pluginSpec.name = "ActorTurtle";
    _pluginSpec.gui = isGuiRequired();
}

/* public */ QVariant TurtlePlugin::customValueFromString(const QByteArray & , const QString & ) const
{
    QVariant result;

    return result;
}

/* public */ QString TurtlePlugin::customValueToString(const QByteArray & , const QVariant & ) const
{
    QString result;

    return result;
}

/* public */ QVariantList TurtlePlugin::defaultTemplateParameters() const
{
    QVariantList result;
    return result;
}

/* public */ QString TurtlePlugin::errorText() const
{
    return errorText_;
}

/* public */ Shared::EvaluationStatus TurtlePlugin::evaluate(quint32 index, const QVariantList & args)
{
    using namespace Shared;
    errorText_.clear();
    result_ = QVariant::Invalid;
    optResults_.clear();
    switch (index) {
        case 0x0000: {
            /* tailUp */
            Q_EMIT asyncRun(index, args);
            return ES_Async;
            break;
        }
        
        case 0x0001: {
            /* tailDown */
            Q_EMIT asyncRun(index, args);
            return ES_Async;
            break;
        }
        
        case 0x0002: {
            /* forward */
            qreal dist = qvariant_cast<qreal>(args[0]);
            module_->runForward(dist);
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_NoResult;
            break;
        }
        
        case 0x0003: {
            /* back */
            qreal dist = qvariant_cast<qreal>(args[0]);
            module_->runBack(dist);
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_NoResult;
            break;
        }
        
        case 0x0004: {
            /* left */
            qreal angle = qvariant_cast<qreal>(args[0]);
            module_->runLeft(angle);
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_NoResult;
            break;
        }
        
        case 0x0005: {
            /* set pen color */
            Color color = decode(args[0]);
            module_->runSetPenColor(color);
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_NoResult;
            break;
        }
        
        case 0x0006: {
            /* right */
            qreal angle = qvariant_cast<qreal>(args[0]);
            module_->runRight(angle);
            optResults_ << QVariant::Invalid;
            if (errorText_.length() > 0) {
                return ES_Error;
            }
            return ES_NoResult;
            break;
        }
        
        
        default : {
            errorText_ = "Unknown method index";
            return ES_Error;
        }
    }
}

/* public */ Shared::ActorInterface::FunctionList TurtlePlugin::functionList() const
{
    Shared::ActorInterface::FunctionList result;
    
    /* алг поднять хвост */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("tailUp");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("поднять хвост");
    result.last().returnType = Shared::ActorInterface::Void;
    
    /* алг опустить хвост */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("tailDown");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("опустить хвост");
    result.last().returnType = Shared::ActorInterface::Void;
    
    /* алг вперед(вещ dist) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("forward");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("вперед");
    result.last().returnType = Shared::ActorInterface::Void;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Real;
    result.last().arguments.last().dimension = 0u;
    
    /* алг назад(вещ dist) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("back");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("назад");
    result.last().returnType = Shared::ActorInterface::Void;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Real;
    result.last().arguments.last().dimension = 0u;
    
    /* алг влево(вещ angle) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("left");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("влево");
    result.last().returnType = Shared::ActorInterface::Void;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Real;
    result.last().arguments.last().dimension = 0u;
    
    /* алг выбрать чернила(цвет color) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("set pen color");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("выбрать чернила");
    result.last().returnType = Shared::ActorInterface::Void;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::RecordType;
    {
        Shared::ActorInterface::RecordSpecification recordSpec;
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("r"), Shared::ActorInterface::Int));
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("g"), Shared::ActorInterface::Int));
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("b"), Shared::ActorInterface::Int));
        recordSpec.record.push_back(Shared::ActorInterface::Field(QByteArray("a"), Shared::ActorInterface::Int));
        recordSpec.asciiName = QByteArray("color");
         recordSpec.localizedNames[QLocale::Russian] = QString::fromUtf8("цвет");
        result.last().arguments.last().typeSpecification = recordSpec;
    }
    result.last().arguments.last().dimension = 0u;
    
    /* алг вправо(вещ angle) */
    result.push_back(Shared::ActorInterface::Function());
    result.last().id = result.size() - 1;
    result.last().accessType = Shared::ActorInterface::PublicFunction;
    result.last().asciiName = QByteArray("right");
    result.last().localizedNames[QLocale::Russian] = QString::fromUtf8("вправо");
    result.last().returnType = Shared::ActorInterface::Void;
    result.last().arguments.push_back(Shared::ActorInterface::Argument());
    result.last().arguments.last().accessType = Shared::ActorInterface::InArgument;
    result.last().arguments.last().type = Shared::ActorInterface::Real;
    result.last().arguments.last().dimension = 0u;
    ;
    return result;
}

/* private slot */ void TurtlePlugin::handleSettingsChangedCppImplementation(const QStringList & keys)
{
    if (module_) {
        module_->reloadSettings(mySettings(), keys);
    }
}

/* protected */ QString TurtlePlugin::initialize(const QStringList &a, const ExtensionSystem::CommandLine &b)
{
    module_ = new TurtleModule(this);
    QMap<QString,Widgets::DeclarativeSettingsPage::Entry> entries;
    
    {
        Widgets::DeclarativeSettingsPage::Entry entry;
        entry.title = QString::fromUtf8("Цвет осей");  // TODO non-Russian language support
        entry.type = Widgets::DeclarativeSettingsPage::Color;
        entry.defaultValue = QString::fromUtf8("#999900");
        entry.minimumValue = QVariant::Invalid;
        entry.maximumValue = QVariant::Invalid;
        entry.items = QStringList();
        entry.displayOrder = 99999999;
        entries["AxisColor"] = entry;
    }
            
    {
        Widgets::DeclarativeSettingsPage::Entry entry;
        entry.title = QString::fromUtf8("Толщина осей");  // TODO non-Russian language support
        entry.type = Widgets::DeclarativeSettingsPage::Integer;
        entry.defaultValue = 2;
        entry.minimumValue = QVariant::Invalid;
        entry.maximumValue = QVariant::Invalid;
        entry.items = QStringList();
        entry.displayOrder = 99999999;
        entries["AxisWidth"] = entry;
    }
            
    {
        Widgets::DeclarativeSettingsPage::Entry entry;
        entry.title = QString::fromUtf8("Цвет фона");  // TODO non-Russian language support
        entry.type = Widgets::DeclarativeSettingsPage::Color;
        entry.defaultValue = QString::fromUtf8("#99FF99");
        entry.minimumValue = QVariant::Invalid;
        entry.maximumValue = QVariant::Invalid;
        entry.items = QStringList();
        entry.displayOrder = 99999999;
        entries["BackColor"] = entry;
    }
            
    {
        Widgets::DeclarativeSettingsPage::Entry entry;
        entry.title = QString::fromUtf8("Цвет сетки");  // TODO non-Russian language support
        entry.type = Widgets::DeclarativeSettingsPage::Color;
        entry.defaultValue = QString::fromUtf8("#669966");
        entry.minimumValue = QVariant::Invalid;
        entry.maximumValue = QVariant::Invalid;
        entry.items = QStringList();
        entry.displayOrder = 99999999;
        entries["LineColor"] = entry;
    }
            
    {
        Widgets::DeclarativeSettingsPage::Entry entry;
        entry.title = QString::fromUtf8("Толщина линий");  // TODO non-Russian language support
        entry.type = Widgets::DeclarativeSettingsPage::Integer;
        entry.defaultValue = 4;
        entry.minimumValue = QVariant::Invalid;
        entry.maximumValue = QVariant::Invalid;
        entry.items = QStringList();
        entry.displayOrder = 99999999;
        entries["LineWidth"] = entry;
    }
            
    {
        Widgets::DeclarativeSettingsPage::Entry entry;
        entry.title = QString::fromUtf8("Толщина сетки");  // TODO non-Russian language support
        entry.type = Widgets::DeclarativeSettingsPage::Integer;
        entry.defaultValue = 1;
        entry.minimumValue = QVariant::Invalid;
        entry.maximumValue = QVariant::Invalid;
        entry.items = QStringList();
        entry.displayOrder = 99999999;
        entries["NetWidth"] = entry;
    }
            
    bool guiAvailable = (qobject_cast<QApplication*>(qApp) != 0);
    #ifdef Q_OS_LINUX
    //guiAvailable = 0 != getenv("DISPLAY");
    #endif
    if (guiAvailable) {
        settingsPage_ = new Widgets::DeclarativeSettingsPage(
                                Shared::actorCanonicalName(localizedModuleName(QLocale::Russian)),
                                mySettings(),
                                entries
                              );
        connect(settingsPage_, SIGNAL(settingsChanged(QStringList)), this, SLOT(handleSettingsChangedCppImplementation(QStringList)));
    }
    
    asyncRunThread_ = new TurtleAsyncRunThread(this, module_);
    QObject::connect(asyncRunThread_, SIGNAL(finished()),
                     this, SIGNAL(sync()));
    QObject::connect(module_, SIGNAL(notifyOnTemplateParametersChanged()),
                     this, SIGNAL(notifyOnTemplateParametersChanged()));
    
    return module_->initialize(a, b);
}

/* public */ bool TurtlePlugin::isGuiRequired() const
{
    return true;
}

/* public */ bool TurtlePlugin::isSafeToQuit()
{
    return module_->isSafeToQuit();
}

/* public slot */ void TurtlePlugin::loadActorData(QIODevice * source)
{
    if (module_) {
        module_->loadActorData(source);
    }
}

/* public */ QString TurtlePlugin::localizedModuleName(const QLocale::Language ) const
{
    // TODO non-Russian languages not implemented yet
    return QString::fromUtf8("Черепаха");
}

/* public */ QString TurtlePlugin::mainIconName() const
{
    return QString::fromLatin1("turtle");
}

/* public */ QWidget* TurtlePlugin::mainWidget()
{
    return module_->mainWidget();
}

/* public */ QList<QMenu*> TurtlePlugin::moduleMenus() const
{
    return module_->moduleMenus();
}

/* protected */ void TurtlePlugin::msleep(unsigned long secs)
{
    //if (QThread::currentThread()==asyncRunThread_) {
        asyncRunThread_->amsleep(secs);
    //}
}

/* public */ void TurtlePlugin::notifyGuiReady()
{
    module_->handleGuiReady();
}

/* public */ QString TurtlePlugin::pultIconName() const
{
    return QString::fromLatin1("turtle-pult");
}

/* public */ QWidget* TurtlePlugin::pultWidget()
{
    return module_->pultWidget();
}

/* public */ void TurtlePlugin::reset()
{
    module_->reset();
}

/* public */ QVariant TurtlePlugin::result() const
{
    return result_;
}

/* public */ void TurtlePlugin::setAnimationEnabled(bool enabled)
{
    // The module might be not created at a time of call,
    // so check it propertly
    if (module_) {
        module_->setAnimationEnabled(enabled);
    }
}

/* public */ QWidget* TurtlePlugin::settingsEditorPage()
{
    return settingsPage_;
}

/* protected */ void TurtlePlugin::sleep(unsigned long secs)
{
    if (QThread::currentThread()==asyncRunThread_) {
        asyncRunThread_->asleep(secs);
    }
}

/* public */ QVariantList TurtlePlugin::templateParameters() const
{
    if (module_) {
        return module_->templateParameters();
    }
    else {
        return defaultTemplateParameters();
    }
}

/* public */ void TurtlePlugin::terminateEvaluation()
{
    module_->terminateEvaluation();
}

/* public */ Shared::ActorInterface::TypeList TurtlePlugin::typeList() const
{
    Shared::ActorInterface::TypeList result;
    
            
    return result;
}

/* private */ void TurtlePlugin::updateSettings(const QStringList & keys)
{
    if (settingsPage_) {
        settingsPage_->setSettingsObject(mySettings());
    }
    if (module_) {
        module_->reloadSettings(mySettings(), keys);
    }
}

/* public */ QList<Shared::ActorInterface*> TurtlePlugin::usesList() const
{
    static const QList<QByteArray> usesNames = QList<QByteArray>()
        << "Actor_Colorer" ;
    QList<Shared::ActorInterface*> result;
    Q_FOREACH (const QByteArray & name, usesNames) {
        ExtensionSystem::KPlugin * plugin = myDependency(name);
        Shared::ActorInterface * actor =
                qobject_cast<Shared::ActorInterface*>(plugin);
        result.push_back(actor);
    }
    return result;
}

/* protected */ void TurtlePlugin::usleep(unsigned long secs)
{
    if (QThread::currentThread()==asyncRunThread_) {
        asyncRunThread_->ausleep(secs);
    }
}



TurtleAsyncRunThread::TurtleAsyncRunThread(class TurtlePlugin* plugin, class TurtleModuleBase* module)
    : QThread(plugin)
    , index_(0)
    , args_(QVariantList())
    , plugin_(plugin)
    , module_(module)
{
}

/* public */ void TurtleAsyncRunThread::amsleep(unsigned long secs)
{
    msleep(secs);
}

/* public */ void TurtleAsyncRunThread::asleep(unsigned long secs)
{
    sleep(secs);
}

/* public */ void TurtleAsyncRunThread::ausleep(unsigned long secs)
{
    usleep(secs);
}

/* public */ void TurtleAsyncRunThread::init(quint32 index, const QVariantList & args)
{
    index_ = index;
    args_ = args;
}

/* private */ void TurtleAsyncRunThread::run()
{
    switch (index_) {
        case 0x0000: {
            /* tailUp */
            module_->runTailUp();
            break;
        }
        case 0x0001: {
            /* tailDown */
            module_->runTailDown();
            break;
        }
        
        default: {
            plugin_->errorText_ = "Unknown method index";
        }
    }
}



} // namespace ActorTurtle
#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN(ActorTurtle::TurtlePlugin)
#endif
